Bug 64727 - [gm45, bisected] some piglit glsl 1.10 built-in-functions tests crash
[gm45, bisected] some piglit glsl 1.10 built-in-functions tests crash
Status: RESOLVED FIXED
Product: Mesa
Classification: Unclassified
Component: Drivers/DRI/i965
git
Other All
: medium normal
Assigned To: Eric Anholt
: regression
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2013-05-17 22:02 UTC by Pavel Ondračka
Modified: 2013-05-29 18:04 UTC (History)
1 user (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Pavel Ondračka 2013-05-17 22:02:09 UTC
shader_runner: brw_vec4.cpp:270: int brw::vec4_visitor::implied_mrf_writes(brw::vec4_instruction*): Assertion `!"not reached"' failed.

Program received signal SIGABRT, Aborted.
0x00000038e3e35ba5 in __GI_raise (sig=sig@entry=6) at ../nptl/sysdeps/unix/sysv/linux/raise.c:63
63	  return INLINE_SYSCALL (tgkill, 3, pid, selftid, sig);
(gdb) bt
#0  0x00000038e3e35ba5 in __GI_raise (sig=sig@entry=6) at ../nptl/sysdeps/unix/sysv/linux/raise.c:63
#1  0x00000038e3e37358 in __GI_abort () at abort.c:90
#2  0x00000038e3e2e972 in __assert_fail_base (fmt=0x38e3f79408 "%s%s%s:%u: %s%sAssertion `%s' failed.\n%n", 
    assertion=assertion@entry=0x7ffff711c11c "!\"not reached\"", file=file@entry=0x7ffff711c0f4 "brw_vec4.cpp", line=line@entry=270, 
    function=function@entry=0x7ffff711c800 <brw::vec4_visitor::implied_mrf_writes(brw::vec4_instruction*)::__PRETTY_FUNCTION__> "int brw::vec4_visitor::implied_mrf_writes(brw::vec4_instruction*)") at assert.c:92
#3  0x00000038e3e2ea22 in __GI___assert_fail (assertion=0x7ffff711c11c "!\"not reached\"", file=0x7ffff711c0f4 "brw_vec4.cpp", line=270, 
    function=0x7ffff711c800 <brw::vec4_visitor::implied_mrf_writes(brw::vec4_instruction*)::__PRETTY_FUNCTION__> "int brw::vec4_visitor::implied_mrf_writes(brw::vec4_instruction*)") at assert.c:101
#4  0x00007ffff70c2c49 in brw::vec4_visitor::implied_mrf_writes (this=0x7fffffff4ae0, inst=0x8fc0e0) at brw_vec4.cpp:270
#5  0x00007ffff70b73b1 in vec4_instruction_scheduler::calculate_deps (this=0x7fffffff49b0) at brw_schedule_instructions.cpp:839
#6  0x00007ffff70b7e78 in instruction_scheduler::run (this=0x7fffffff49b0, all_instructions=0x7fffffff4b18) at brw_schedule_instructions.cpp:1109
#7  0x00007ffff70b8003 in brw::vec4_visitor::opt_schedule_instructions (this=0x7fffffff4ae0) at brw_schedule_instructions.cpp:1143
#8  0x00007ffff70c69e5 in brw::vec4_visitor::run (this=0x7fffffff4ae0) at brw_vec4.cpp:1475
#9  0x00007ffff70c6bfc in brw_vs_emit (brw=0x628b40, prog=0x8f0970, c=0x7fffffffda20, prog_data=0x7fffffffd950, mem_ctx=0x8e56d0, 
    final_assembly_size=0x7fffffffda84) at brw_vec4.cpp:1533
#10 0x00007ffff70edbc9 in do_vs_prog (brw=0x628b40, prog=0x8f0970, vp=0x918c40, key=0x7fffffffdaf0) at brw_vs.c:318
#11 0x00007ffff70ee94a in brw_vs_precompile (ctx=0x628b40, prog=0x8f0970) at brw_vs.c:580
#12 0x00007ffff70bbd6d in brw_shader_precompile (ctx=0x628b40, prog=0x8f0970) at brw_shader.cpp:72
#13 0x00007ffff70bc605 in brw_link_shader (ctx=0x628b40, shProg=0x8f0970) at brw_shader.cpp:288
#14 0x00007ffff6c33646 in _mesa_glsl_link_shader (ctx=0x628b40, prog=0x8f0970) at ../../../src/mesa/program/ir_to_mesa.cpp:3214
#15 0x00007ffff6a5792c in link_program (ctx=0x628b40, program=3) at ../../../src/mesa/main/shaderapi.c:784
#16 0x00007ffff6a58ac7 in _mesa_LinkProgram (programObj=3) at ../../../src/mesa/main/shaderapi.c:1280
#17 0x00007ffff737ddba in shared_dispatch_stub_509 (program=3) at ../../../src/mapi/shared-glapi/glapi_mapi_tmp.h:16437
#18 0x00007ffff7ad8692 in stub_glLinkProgram (program=3) at /home/Paulie/piglit/tests/util/generated_dispatch.c:15012
#19 0x0000000000405403 in link_and_use_shaders () at /home/Paulie/piglit/tests/shaders/shader_runner.c:789
#20 0x0000000000408ad3 in piglit_init (argc=2, argv=0x7fffffffdf68) at /home/Paulie/piglit/tests/shaders/shader_runner.c:1993
#21 0x00007ffff7ab9b0a in run_test (gl_fw=0x7ffff7d8cc00 <glut_fw>, argc=2, argv=0x7fffffffdf68)
    at /home/Paulie/piglit/tests/util/piglit-framework-gl/piglit_glut_framework.c:140
#22 0x00007ffff7ab7bd1 in piglit_gl_test_run (argc=2, argv=0x7fffffffdf68, config=0x7fffffffde50)
    at /home/Paulie/piglit/tests/util/piglit-framework-gl.c:127
#23 0x0000000000403ee6 in main (argc=3, argv=0x7fffffffdf68) at /home/Paulie/piglit/tests/shaders/shader_runner.c:58

Affected piglit tests:
bin/ext_framebuffer_multisample-enable-flag -auto
generated_tests/spec/glsl-1.10/execution/built-in-functions/vs-op-div-int-int
generated_tests/spec/glsl-1.10/execution/built-in-functions/vs-op-div-int-ivec2
generated_tests/spec/glsl-1.10/execution/built-in-functions/vs-op-div-int-ivec3
generated_tests/spec/glsl-1.10/execution/built-in-functions/vs-op-div-int-ivec4
generated_tests/spec/glsl-1.10/execution/built-in-functions/vs-op-div-ivec2-int
generated_tests/spec/glsl-1.10/execution/built-in-functions/vs-op-div-ivec2-ivec2
generated_tests/spec/glsl-1.10/execution/built-in-functions/vs-op-div-ivec3-int
generated_tests/spec/glsl-1.10/execution/built-in-functions/vs-op-div-ivec3-ivec3
generated_tests/spec/glsl-1.10/execution/built-in-functions/vs-op-div-ivec4-int
generated_tests/spec/glsl-1.10/execution/built-in-functions/vs-op-div-ivec4-ivec4
generated_tests/spec/glsl-1.10/execution/built-in-functions/vs-op-eq-mat3-mat3

first bad commit:
commit 573d8813fdbb116f4500d2044c56d80aab73ab7f
Author: Eric Anholt <eric@anholt.net>
Date:   Fri Nov 30 16:13:34 2012 -0800

    i965/vs: Add instruction scheduling.
    
    While this is ignorant of dependency control, it's still good for a 0.39%
    +/- 0.08% performance improvement on GLBenchmark 2.7 (n=548)
    
    v2: Rewrite as a subclass of the base class for the FS instruction
        scheduler, inheriting the same latency information.
    
    Reviewed-by: Kenneth Graunke <kenneth@whitecape.org>
    Reviewed-by: Matt Turner <mattst88@gmail.com>

GPU:gm45
Mesa: 6166ffeaf70e96e3f94417f8db79ba2440462178
Kernel: 3.8.11-200.fc18.x86_64
Comment 1 Eric Anholt 2013-05-28 23:36:23 UTC
Patch is on the list.
Comment 2 Eric Anholt 2013-05-29 18:04:46 UTC
commit 6220cc931f15ddb428ea481e8b9a70ce26ca3304
Author: Eric Anholt <eric@anholt.net>
Date:   Tue May 28 14:35:19 2013 -0700

    i965/vs: Fix implied_mrf_writes() for integer division pre-gen6.